Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
**************************************************************************************************************************
bfs(),加点数学知识
**************************************************************************************************************************
1 #include<iostream> 2 #include<string> 3 #include<cstring> 4 #include<cmath> 5 #include<cstdio> 6 #include<queue> 7 using namespace std; 8 int prime[10001]; 9 queue<int>Q; 10 int vis[10001]; 11 int dis[10001]; 12 int cas; 13 int s,r; 14 void init() 15 { 16 memset(prime,0,sizeof(prime)); 17 for(int i=1001;i<10000;i++) 18 { 19 int flag=1; 20 for(int j=2;j<=sqrt(i);j++) 21 if(i%j==0) 22 { 23 flag=0; 24 break; 25 } 26 if(flag==1) 27 prime[i]=1; 28 } 29 } 30 int bfs(int s,int r) 31 { 32 int se; 33 while(!Q.empty()) 34 Q.pop(); 35 Q.push(s); 36 vis[s]=1; 37 while(!Q.empty()) 38 { 39 int u=Q.front(); 40 Q.pop(); 41 for(int it=0;it<=9;it++) 42 { 43 se=(u/10)*10+it; 44 if(prime[se]&&!vis[se]) 45 { 46 dis[se]=dis[u]+1; 47 Q.push(se); 48 vis[se]=1; 49 } 50 se=u%10+(u/100)*100+it*10; 51 if(!vis[se]&&prime[se]) 52 { 53 dis[se]=dis[u]+1; 54 Q.push(se); 55 vis[se]=1; 56 } 57 se=u%100+(u/1000)*1000+it*100; 58 if(!vis[se]&&prime[se]) 59 { 60 dis[se]=dis[u]+1; 61 Q.push(se); 62 vis[se]=1; 63 } 64 if(it>0) 65 { 66 se=u%1000+it*1000; 67 if(!vis[se]&&prime[se]) 68 { 69 dis[se]=dis[u]+1; 70 Q.push(se); 71 vis[se]=1; 72 } 73 } 74 } 75 if(vis[r]==1) 76 return dis[r]; 77 } 78 } 79 int main() 80 { 81 init(); 82 scanf("%d",&cas); 83 while(cas--) 84 { 85 scanf("%d%d",&s,&r); 86 memset(dis,0,sizeof(dis)); 87 memset(vis,0,sizeof(vis)); 88 printf("%d\n",bfs(s,r)); 89 } 90 }